// Quartz Example 2006.07.21 by H.K.

#import "MyView.h"
#include <math.h>

double x[2], xm[2], ym[2], alpha[2];
double t;
int w, h;
//definition at this place can be available both in functions and in methods
//On the other hand, the defintion in @interface{} of "MyView.h"
//is only available in methods

void func(double x[], double t)
{
	x[0] = cos(t)+2.0*sin(t/8.0)+cos(t/64.0)/8.0+sin(4.0*t)/2.0;
	x[1] = sin(t)-2.0*cos(t/8.0)+sin(t/64.0)/8.0-cos(4.0*t)/2.0;
}

@implementation MyView

- (id)initWithFrame:(NSRect)frameRect
{
	if ((self = [super initWithFrame:frameRect]) != nil) {
		xm[0]=-4.0; xm[1]=4.0; ym[0]=-4.0; ym[1]=4.0;
		t=0.0;
        
		[NSTimer scheduledTimerWithTimeInterval:0.01
                                         target:self
                                       selector:@selector(drawAnother:)
                                       userInfo:nil
                                        repeats:YES];
		[NSBezierPath setDefaultLineWidth:1];
	}
	return self;
}

- (void)drawRect:(NSRect)rect
{
    path=[NSBezierPath bezierPath];

	NSRect bounds=[self bounds];
	[[NSColor whiteColor] set];
	[NSBezierPath fillRect:bounds];
    
	w = rect.size.width;
    h = rect.size.height;
	alpha[0] = w/(xm[1]-xm[0]);
	alpha[1] = h/(ym[1]-ym[0]);

	[path moveToPoint:NSMakePoint(0.0, h/2.0+0.5)];
	[path lineToPoint:NSMakePoint(w, h/2.0+0.5)];
	[path moveToPoint:NSMakePoint(w/2.0+0.5, 0.0)];
	[path lineToPoint:NSMakePoint(w/2.0+0.5, h)];
    [path setLineWidth:1.0];
    [[NSColor blueColor] set];
    [path stroke];
}

- (void) myDraw
{
	double a[2],u[2];
    	
    path=[NSBezierPath bezierPath];
    for(int i=0; i<10;i++){ // drawing speed is controlled by imax=10
        func(x, t);
        a[0]=alpha[0]*(x[0]-xm[0]);
        a[1]=alpha[1]*(x[1]-ym[0]);
        t+=0.05;
        func(x, t);
        u[0]=alpha[0]*(x[0]-xm[0]);
        u[1]=alpha[1]*(x[1]-ym[0]);
//    [NSBezierPath strokeLineFromPoint:NSMakePoint(a[0], a[1]) toPoint:NSMakePoint(u[0], u[1])];

        [path moveToPoint:NSMakePoint(a[0], a[1])];
        [path lineToPoint:NSMakePoint(u[0], u[1])];

        [path setLineWidth:1.0];
        [[NSColor blueColor] set];
        [path stroke];
    }
}

- (void)drawAnother:(id)timer
{
	[self lockFocus];
	[self myDraw];
	[self unlockFocus];
	[[self window] flushWindow];
}

@end
